﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using WebApi.Models;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;
using System.Web.Http.OData.Routing;
using System.Web.Http.OData.Properties;
using System.Web.Http.OData.Builder;




namespace WebApi.Controllers
{
    public class treeController : ApiController
    {
        // GET api/tree
        public IEnumerable<object> Get(ODataQueryOptions opt)
        {
            List<treemodel> treeobj = new List<treemodel>();
            treeobj.Add(new treemodel { id = "1", name = "Local Disk(C)", hasChild = true, isChecked = true});
            treeobj.Add(new treemodel { id = "2",pid="1", name = "File1", isChecked = false});
            treeobj.Add(new treemodel { id = "3", pid = "1", name = "File2", isChecked = true });
            treeobj.Add(new treemodel { id = "3", pid = "1", name = "File3", isChecked = false });
            treeobj.Add(new treemodel { id = "3", pid = "1", name = "File4", isChecked = false });
            treeobj.Add(new treemodel { id = "4", name = "Local Disk(D)", hasChild = true, isChecked = true });
            treeobj.Add(new treemodel { id = "5", pid = "4", name = "File1", isChecked = true});
            treeobj.Add(new treemodel { id = "6", pid = "4", name = "File2", isChecked = false });
            treeobj.Add(new treemodel { id = "3", pid = "1", name = "File3", isChecked = true });
            treeobj.Add(new treemodel { id = "3", pid = "1", name = "File4", isChecked = false });
            var data = treeobj.Where(p => p.pid == "0" || p.pid == null);  // To filter first level data.
            if (opt.Filter != null)  // Filter value comes while we expand a node, then the child data will be filtered based on the filter condition.
            {
                string values = opt.Filter.RawValue.Substring(opt.Filter.RawValue.IndexOf("eq") + 3).Replace("'", String.Empty);
                data = treeobj.Where(p => p.pid == values);
            }
            return data;
        }

        // GET api/tree/5
        public string Get(int id)
        {
            return "value";
        }

        // POST api/tree
        public void Post([FromBody] string s)
        {
        }

        // PUT api/tree/5
        public void Put(int id, [FromBody] string s)
        {
        }

        // DELETE api/tree/5
        public void Delete(int id)
        {
        }
        }
}
